#Loading the functions to calculate real archetypes (set the working directory where the functions and data to 
#load are placed):
source("Functions_to_calculate_real_archetypes_with_swap2.R")
source("stepArchetypesMod.R")
source("stepArchetypoids.R")

#First, we read the matrix provided with the dissimilarities:
db=read.table('Matr_Dist_470mujs.txt')
n=470
p=princomp(db)
v=p$loadings
pr=p$sdev
pv=cbind(pr[1]*v[1:(n),1],pr[2]*v[1:(n),2],pr[3]*v[1:(n),3],pr[4]*v[1:(n),4])

#goodness of fit
sum(c(pr[1]^4,pr[2]^4,pr[3]^4,pr[4]^4))/sum(pr^4) #first to fourth

X=pv

######
#Fig. 7
set.seed(2014)
#Run archetypes algorithm repeatedly from 1 to 10 archetypes:
lass10 <- stepArchetypesMod(data = X, k = 1:10, verbose = FALSE, nrep = 20) 
screeplot(lass10)

rss_lass <- matrix(0,nrow=10,ncol=20)
for(i in 1:10){
  for(j in 1:20){
    rss_lass[i,j] <- lass10[[i]][[j]]$rss
  }
}
(rss_lass_def <- apply(rss_lass,1,min,na.rm=T))
#[1] 1.992363e-05 1.242968e-05 7.015145e-06 5.334728e-06 4.369622e-06 3.579434e-06 3.437408e-06 3.140979e-06 2.871741e-06
#[10] 2.750908e-06
rss_lass_def <- c(1.992363e-05, 1.242968e-05, 7.015145e-06, 5.334728e-06, 4.369622e-06, 
                  3.579434e-06, 3.437408e-06, 3.140979e-06, 2.871741e-06, 2.750908e-06)

for(i in 1:10){
  temp <-  stepArchetypoids(i,TRUE,X,lass10,sequ=TRUE)
  filename <- paste("res", i, sep="")
  assign(filename,temp)
  save(list=c(filename),file=paste(filename, ".RData", sep="")) 
}  

for(i in 1:10){
  temp <-  stepArchetypoids(i,FALSE,X,lass10,sequ=TRUE)
  filename <- paste("res", i, "_which",sep="")
  assign(filename,temp)
  save(list=c(filename),file=paste(filename, ".RData", sep=""))
} 

for(i in 1:10){
 ai <- bestModel(lass10[[i]])
 ini_arch=c()
  for (j in 1:i){
   ini_arch[j]=which.max(ai$betas[j,])
  }
temp <- realArchetypes(X,huge = 200, i, ini_arch)
temp
filename <- paste("res", i, "_whichbe",sep="")
assign(filename,temp)
save(list=c(filename),file=paste(filename, ".RData", sep=""))
}  


#Screeplot Furthseum, computed in Matlab
furth=list(i1=1,i2=c( 264  , 383 ), i3=c( 414 ,  383 ,  170),
i4=c( 300 ,  383  , 180 ,  414),i5=c( 414  , 310 ,  300  , 170 ,  383 ),
i6=c( 267  , 383  , 264  , 414 ,  300 ,  170),
i7=c(170 ,  427 ,  414 ,  383   ,264 ,  265,   300),
i8=c( 300  , 170 ,  267  , 414 ,  427 ,  383,   264,   124),
i9=c( 310 ,  300  , 287 ,  265 ,  414,   427  , 180   ,383 ,  264 ),
i10=c(124 ,  310  , 300 ,  264,   267  , 414  , 427 ,  170 ,  287  , 383))


for(i in 1:10){
 ini_arch=furth[[i]]
 temp <- realArchetypes(X,huge = 200, i, ini_arch)
 temp
 filename <- paste("res", i, "_fu",sep="")
 assign(filename,temp)
 save(list=c(filename),file=paste(filename, ".RData", sep=""))
}  

for(i in 1:10){
  load(paste("res", i, ".RData", sep = ""))
}
rss_step <- c()
for (i in 1:10){ 
  rss_step[i] <- get(paste("res", i, sep = ""))[[2]]
}
(rss_step <- as.numeric(rss_step))
# [1] 1.992367e-05 1.243073e-05 7.003296e-06 5.313024e-06 4.121539e-06 3.354186e-06 3.080695e-06 2.825066e-06 2.375918e-06
# [10] 2.547148e-06

for(i in 1:10){ 
  load(paste("res", i, "_which.RData", sep = ""))
}
rss_step_which <- c()
for (i in 1:10){ 
  rss_step_which[i] <- get(paste("res", i, "_which", sep = ""))[[2]]
}
(rss_step_which <- as.numeric(rss_step_which))
#[1] 1.992367e-05 1.243073e-05 7.003296e-06 5.664007e-06 4.121539e-06 3.354186e-06 3.018187e-06 2.829868e-06 2.610538e-06
#[10] 2.489736e-06

for(i in 1:10){
  load(paste("res", i, "_whichbe.RData", sep = ""))
}
rss_step_whichbe <- c()
for (i in 1:10){
  rss_step_whichbe[i] <- get(paste("res", i, "_whichbe", sep = ""))[[2]]
}
(rss_step_whichbe <- as.numeric(rss_step_whichbe))
#[1] 1.992367e-05 1.243073e-05 7.003296e-06 5.686089e-06 4.121539e-06 3.354186e-06 3.080695e-06 2.825066e-06 2.563574e-06
#[10] 2.385546e-06

for(i in 1:10){
  load(paste("res", i, "_fu.RData", sep = ""))
}
rss_step_fu <- c()
for (i in 1:10){
  rss_step_fu[i] <- get(paste("res", i, "_fu", sep = ""))[[2]]
}
(rss_step_fu <- as.numeric(rss_step_fu))
#[1] 1.992367e-05 1.243073e-05 7.002191e-06 6.056030e-06 4.228737e-06 3.701920e-06 3.091279e-06 3.054033e-06 2.671296e-06
#[10] 2.566738e-06

plot(1:10,rss_lass_def,xaxt="n",yaxt="n",ylim=c(0,2e-05),xlab="Archetypes/Archetypoids",ylab="RSS",type="b") 
points(1:10,rss_step,type="b",col="red") 
points(1:10,rss_step_which,type="b",col="blue",lty=2)
points(1:10,rss_step_whichbe,type="b", col="green",lty=6)
points(1:10,rss_step_fu,type="b", col="magenta",lty=3)
axis(1,at=1:10,labels=1:10)
axis(2,at=seq(0,2e-05,5e-06),labels=seq(0,2e-05,5e-06))
legend("topright",c("Archetypes",
                    expression(paste("Archetypoids from ", cand[ns])),
                    expression(paste("Archetypoids from ", cand[alpha])),
                    expression(paste("Archetypoids from ", cand[beta])),
                    expression(paste("Archetypoids from ", cand[FS]))),
       lty = c(1,1,2,6,3),
       col=c("black","red","blue","green3","magenta"),
       text.col=c("black","red","blue","green3","magenta"))
#Fig. 7 end

#Table 4 
norep=20
set.seed(2014)
lass10 <- stepArchetypesMod(data=X,k=K,verbose=FALSE,nrep=norep) 
ai <- bestModel(lass10[[1]]) #archetypes
 
an6 <-  stepArchetypoids(K,TRUE,x,lass10,FALSE,K-1) #nearest archetypoids
aw6 <-  stepArchetypoids(K,FALSE,x,lass10,FALSE,K-1) #which_alpha archetypoids


ai$betas
which.max(ai$betas[1,])
which.max(ai$betas[2,])
which.max(ai$betas[3,])

ini_arch=c(171,217,287)
res <- realArchetypes(X,huge = 200, 3, ini_arch)#which_beta archetypoids

   
#Furthesum
ini_arch=c( 414 ,  383 ,  170) 
res <- realArchetypes(X,huge = 200, 3, ini_arch) #Furthestsum arcehtypoids



vect_arch_ini=c(171,217,287) #which_betas
#Furthestsum from Matlab vect_arch_ini=c( 414 ,  383 ,  170) 
#
#vect_arch_ini=an6[[3]] #nearest
#vect_arch_ini=aw6[[3]] #which_alpha
      
      k <- length(vect_arch_ini)
      
      x_gvv <- rbind(t(data), rep(huge, n))
      
      zs <- x_gvv[, vect_arch_ini] 
      zs <- as.matrix(zs)
      alphas <- matrix(0, nrow = k, ncol = n)
      for (j in 1 : n){
        alphas[, j] = coef(nnls(zs, x_gvv[,j]))
      }
      
      resid <- zs %*% alphas - x_gvv
      
      auxrss=max(svd(resid)$d) / n
   

