#First, we read and preprocess the database USAF 1967 (Zehner et al.):
m <- read.table('med1967.dat', sep = " ")
#Variable selection:
sel <- c(48, 40 ,39, 33, 34, 36)
#Changing to inches: 
mpulg <- m[,sel] / (10 * 2.54)
#Standarizing (normalizing):
smpulg <- scale(mpulg, center = sapply(mpulg,mean), scale = sapply(mpulg,sd)) 

#Next, we remove the more extreme 5% data using the Mahalanobis distance.
Sx <- cov(smpulg)
D2 <- mahalanobis(smpulg, colMeans(smpulg), Sx)

#Individuals considered for covering 95%:
qlchi <- which(D2 <= qchisq(0.95, df = dim(mpulg)[2])) 
#Database with the 6 variables and the selected individuals:
lsmpulg <- smpulg[qlchi,] 

library(archetypes)

data=lsmpulg
huge=200

vect_arch_ini = c(511,314,1691)    #nearest
#vect_arch_ini = c(1421,314,1691)  #which_alpha

k <- length(vect_arch_ini)
n <- ncol(t(data))

x_gvv <- rbind(t(data), rep(huge, n))

zs <- x_gvv[, vect_arch_ini]  
zs <- as.matrix(zs)
alphas <- matrix(0, nrow = k, ncol = n)
for (j in 1 : n){
 alphas[, j] = coef(nnls(zs, x_gvv[,j]))
}

resid <- zs %*% alphas - x_gvv 

max(svd(resid)$d) / n
#[1] 0.01824692 #for nearest
#[1] 0.01947072 #for which


#which_beta

vect_arch_ini=c(2027,611,1114)
      
      k <- length(vect_arch_ini)
      
      x_gvv <- rbind(t(data), rep(huge, n))
      
      zs <- x_gvv[, vect_arch_ini] 
      zs <- as.matrix(zs)
      alphas <- matrix(0, nrow = k, ncol = n)
      for (j in 1 : n){
        alphas[, j] = coef(nnls(zs, x_gvv[,j]))
      }
      
      resid <- zs %*% alphas - x_gvv
      
      auxrss=max(svd(resid)$d) / n
      

#FURTHESTSUM (obtained with Matlab)

vect_arch_ini=c(  187    ,    1114   ,     1560) 
      
      k <- length(vect_arch_ini)
      
      x_gvv <- rbind(t(data), rep(huge, n))
      
      zs <- x_gvv[, vect_arch_ini] 
      zs <- as.matrix(zs)
      alphas <- matrix(0, nrow = k, ncol = n)
      for (j in 1 : n){
        alphas[, j] = coef(nnls(zs, x_gvv[,j]))
      }
      
      resid <- zs %*% alphas - x_gvv
      
      auxrss=max(svd(resid)$d) / n

#> auxrss
#[1] 0.0141764
