#Archetypoids in R:
library(archetypes)
library(Anthropometry)

m <- read.table('med1967.dat', sep = " ")
m <- m[1:20,]
sel <- c(48, 40 ,39, 33, 34, 36)
mpulg <- m[,sel] / (10 * 2.54)
smpulg <- scale(mpulg, center = sapply(mpulg,mean), scale = sapply(mpulg,sd)) 
Sx <- cov(smpulg)
D2 <- mahalanobis(smpulg, colMeans(smpulg), Sx)
qlchi <- which(D2 <= qchisq(0.95, df = dim(mpulg)[2])) 
lsmpulg <- smpulg[qlchi,]

set.seed(2010) 
lass <- vector("list", 3)
ptm <- proc.time()
lass[[3]] <- stepArchetypesMod(data = lsmpulg, k = 3, verbose = FALSE, nrep = 20) 
a3 <- bestModel(lass[[3]])

x0_alphas <- as.vector(t(a3$alphas))
x0_betas <- as.vector(t(a3$betas))
x0 <- c(x0_alphas, x0_betas)
write.table(t(x0), 'xcRev.txt', row.names = F, col.names = F, append = T) 

i <- 3
#Nearest archetypoids:
#res <- archetypoids(i, lsmpulg, huge = 200, step = FALSE, ArchObj = lass, nearest = TRUE, sequ = TRUE)
#proc.time() - ptm

#Which archetypoids:
res_which <- archetypoids(i, lsmpulg, huge = 200, step = FALSE, ArchObj = lass, nearest = FALSE, sequ = TRUE)
proc.time() - ptm
 
