%Branch and bound algorithm in Matlab:
data = load('med1967.dat'); 
data = data(1:200,:);
sel = [48 40 39 33 34 36];
datapulg = data(:,sel) / (10 * 2.54);
siz = size(datapulg);
smpulg = zscore(datapulg);

Sx = cov(smpulg);
for I = 1 : siz(1)
     D2(I,:) = (smpulg(I,:) -  mean(smpulg)) * inv(Sx) * (smpulg(I,:) - mean(smpulg))'; 
end 
qlchi = find(D2 <= chi2inv(0.95,siz(2))); 
lsmpulg = smpulg(qlchi,:);

save lsmpulg.txt lsmpulg -ASCII

n = size(lsmpulg,1); 
m = size(lsmpulg,2);
p = 3;

x0 = load('xcRev.txt');
x0(x0 > 1) = 1;
xstat = [zeros(1,n*p) ones(1,n*p)]; 
xl = zeros(1,2*n*p);
xu = ones(1,2*n*p);
for i = 1 : n
    Aeq(i, ((i-1)*p + 1) : i*p) = 1;
end
for k = 1 : p
    Aeq(n + k, (n*(p + (k-1)) + 1) : n*(p+k)) = 1;
end    

Beq = ones(n + p,1);

A = [];
B = [];

[err, f, x] = BNBDef('arquetG3m', x0', xstat', xl', xu', A, B, Aeq, Beq);

sum(x(1:n*p)) %For 200 individuals must sum up to 200.
sum(x((n*p+1):2*n*p)) %For 3 archetypoids must sum up to 3.

%Computation of archetypoids
bet = x(n*p+1 : 2*n*p); %Vector with betas coeeficients.
%First archetypoid:
bet_k_1 = bet(1:n); 
arque1 = bet_k_1' * lsmpulg; 
find(ismember(lsmpulg, arque1, 'rows')) 
%Second archetypoid:
bet_k_2 = bet((n+1):2*n); 
arque2 = bet_k_2' * lsmpulg; 
find(ismember(lsmpulg, arque2, 'rows')) 
%Third archetypoid:
bet_k_3 = bet((2*n+1):3*n); 
arque3 = bet_k_3' * lsmpulg;
find(ismember(lsmpulg, arque3, 'rows')) 



 


